@ECHO OFF

:: Check WMIC is available
WMIC.EXE Alias /? >NUL 2>&1 || GOTO s_error

:: Use WMIC to retrieve date and time
FOR /F "skip=1 tokens=1-6" %%G IN ('WMIC Path Win32_LocalTime Get Day^,Hour^,Minute^,Month^,Second^,Year /Format:table') DO (
   IF "%%~L"=="" goto s_done
      Set _yyyy=%%L
      Set _mm=00%%J
      Set _dd=00%%G
      Set _hour=00%%H
      SET _minute=00%%I
      SET _second=00%%K
)
:s_done

:: Pad digits with leading zeros
      Set _mm=%_mm:~-2%
      Set _dd=%_dd:~-2%
      Set _hour=%_hour:~-2%
      Set _minute=%_minute:~-2%
      Set _second=%_second:~-2%

Set logtimestamp=%_yyyy%-%_mm%-%_dd%_%_hour%_%_minute%_%_second%
goto make_dump

:s_error
echo WMIC is not available, using default log filename
Set logtimestamp=_

:make_dump
set FILENAME=%logtimestamp%

REM Above code obtained from http://stackoverflow.com/questions/1192476/format-date-and-time-in-a-windows-batch-script/16349176#16349176


REM Script to backup B4A source with compile timeanddate stamp using 7zip with custom build action
REM (C) Sunish Issac, August 31 2016 , tested with B4A 5.X and Windows 10 64bit

REM Following line to be added in B4A CustomBuildAction  remove REM
REM #CustomBuildAction: 4,Drive:\PathToThisFile\Auto7Zip4B4A.cmd,..\  ..\Backup\ProjectName\

REM change ..\Backup\ProjectName to ..\Backup\ProjectName\ProjectName if you want projectname to be appended to zip filename
REM the Backup folder will be created above the project files folder

cd /d %1  
"C:\Program files\7-Zip\7z.exe"  a -tzip %2%FILENAME%.zip *.* -r -x!bin -x!gen -x!src -x!*.dex  

REM change above path if 7zip is installed in a different location
REM "a" add files to archive
REM "-x!" exclude files/folders
REM -r recurse folder
 